/*
 * IO Priority Utilities - iop.h
 *
 * Copyright (C) 2004 Josef "Jeff" Sipek <jeffpc@optonline.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __IOP_H
#define __IOP_H

#define PRIO_PROCESS    0
#define PRIO_PGRP       1
#define PRIO_USER       2

#define __NR_io_prio		289
#define __NR_getiopriority	290
#define __NR_setiopriority	291

#define _syscall1(type,name,type1,arg1) \
	type name(type1 arg1) \
{ \
	long __res; \
	__asm__ volatile ("int $0x80" \
				: "=a" (__res) \
				: "0" (__NR_##name),"b" ((long)(arg1))); \
	__syscall_return(type,__res); \
}

#define _syscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
__syscall_return(type,__res); \
}

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
__syscall_return(type,__res); \
}

_syscall1(int, io_prio, int, arg);
_syscall2(int, getiopriority, int, a1, int, a2);
_syscall3(int, setiopriority, int, a1, int, a2, int, a3);

#endif
