/*
 * IO Priority Utilities - lsiop.c
 *
 * Copyright (C) 2004 Josef "Jeff" Sipek <jeffpc@optonline.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <asm/unistd.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>

#include "iop.h"

int main(int argc, char** argv)
{
	int o;
	char cmd[512];
	int fd;

	if (argc!=2) {
		printf("Usage: %s <pid>\n", argv[0]);
		return 0;
	}
	
	o = getiopriority(PRIO_PROCESS, atoi(argv[1]));
	if (o < 0)
		return 1;
	snprintf(cmd, 511, "/proc/%d/cmdline", atoi(argv[1]));
	fd = open(cmd, 0);
	if (!fd) {
		strcpy(cmd, "(error reading /proc)");
		goto printit;
	}
	
	strcpy(cmd, "(none)");
	read(fd, cmd, 511);
	close(fd);
	
printit:
	printf("%5d\t%2d\t%s\n", atoi(argv[1]), o, cmd);
	
	return 0;
}
