/*
 * IO Priority Utilities - reiop.c
 *
 * Copyright (C) 2004 Josef "Jeff" Sipek <jeffpc@optonline.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <asm/unistd.h>
#include <errno.h>
#include <unistd.h>

#include "iop.h"

#define tonice(x)	(-(x)-20)

int main(int argc, char** argv)
{
	int o, n, e;

	if (argc!=3) {
		printf("Usage: %s <prio> <pid>\n",argv[0]);
		return 0;
	}
	o = getiopriority(PRIO_PROCESS, atoi(argv[2]));
	if ((e = setiopriority(PRIO_PROCESS, atoi(argv[2]), atoi(argv[1]))))
		return 1;
	n = getiopriority(PRIO_PROCESS, atoi(argv[2]));
	
	printf("%d: old io priority %d, new priority %d\n", atoi(argv[2]), tonice(o), tonice(n));
	
	return 0;
}
